FROM spark-base:latest

COPY start-worker.sh /

ENV SPARK_WORKER_WEBUI_PORT 8081
ENV SPARK_WORKER_LOG /spark/logs
ENV SPARK_MASTER "spark://spark-master:7077"

RUN export SPARK_HOME=/spark
RUN export PATH=$PATH:$SPARK_HOME/bin

# Download Spark Packages
RUN wget http://dl.bintray.com/spark-packages/maven/graphframes/graphframes/0.7.0-spark2.4-s_2.11/graphframes-0.7.0-spark2.4-s_2.11.jar -qO $SPARK_HOME/jars/graphframes.jar
RUN wget https://repo1.maven.org/maven2/org/apache/spark/spark-avro_2.11/2.4.3/spark-avro_2.11-2.4.3.jar -qO $SPARK_HOME/jars/spark-avro.jar
RUN wget https://repo1.maven.org/maven2/com/databricks/spark-csv_2.11/1.5.0/spark-csv_2.11-1.5.0.jar -qO $SPARK_HOME/jars/spark-csv_2.11-1.5.0.jar
RUN wget https://repo1.maven.org/maven2/com/databricks/spark-xml_2.11/0.6.0/spark-xml_2.11-0.6.0.jar -qO $SPARK_HOME/jars/spark-xml_2.11-0.6.0.jar
RUN wget https://repo1.maven.org/maven2/org/apache/commons/commons-csv/1.1/commons-csv-1.1.jar -qO $SPARK_HOME/jars/commons-csv-1.1.jar
RUN wget https://repo1.maven.org/maven2/com/univocity/univocity-parsers/1.5.1/univocity-parsers-1.5.1.jar -qO $SPARK_HOME/jars/univocity-parsers-1.5.1.jar
RUN wget https://repo1.maven.org/maven2/commons-io/commons-io/2.6/commons-io-2.6.jar -qO $SPARK_HOME/jars/commons-io-2.6.jar

RUN wget https://repo1.maven.org/maven2/org/mongodb/spark/mongo-spark-connector_2.11/2.4.1/mongo-spark-connector_2.11-2.4.1.jar -qO $SPARK_HOME/jars/mongo-spark-connector_2.11-2.4.1.jar
RUN wget https://repo1.maven.org/maven2/org/mongodb/mongo-java-driver/3.10.2/mongo-java-driver-3.10.2.jar -qO $SPARK_HOME/jars/mongo-java-driver-3.10.2.jar

EXPOSE 8081

CMD ["/bin/bash", "/start-worker.sh"]
